package gov.usgs.earthquake.nshmp.model;

import gov.usgs.earthquake.nshmp.geo.Location;
import gov.usgs.earthquake.nshmp.mfd.Mfd;

/**
 * A rupture set; usually some physical or pseudo-representation of a fault and
 * associated {@link Mfd}s governing the size and rate of all possible
 * {@link Rupture}s.
 *
 * @author U.S. Geological Survey
 */
public interface RuptureSet {

  /**
   * The display name of the rupture set.
   */
  String name();

  /**
   * The numeric ID of this rupture set.
   */
  int id();

  /**
   * The number of {@link Rupture}s in the rupture set.
   */
  int size();

  /**
   * The {@code SourceType} identifier.
   */
  SourceType type();

  /**
   * The {@code Location} of this source relative to the supplied {@code site}
   * location. The details of what this method returns are implementation
   * secific.
   */
  Location location(Location site);
  // TODO this isn't a good method name

}
